from wxPython.wx import *
from lsListControl import lsListCtrl
from os.path import isdir
from os import listdir, chdir, getcwd, stat
from time import ctime

class FileListCtrl(lsListCtrl):
    def __init__(self, parent, lID):
        lsListCtrl.__init__(self, parent, lID)                                      
        tID = NewId()
        self.locationText = wxTextCtrl(self, tID, "", wxDefaultPosition,
                                       wxDefaultSize, wxTE_PROCESS_ENTER)
        tc = wxLayoutConstraints()
        tc.top.SameAs(self, wxTop, 0)
        tc.left.SameAs(self, wxLeft, 0)
        tc.bottom.Absolute(20)
        tc.right.SameAs(self, wxRight, 20)
        self.locationText.SetConstraints(tc)
        EVT_TEXT_ENTER(self, tID, self.LocationTextEnter)
        
        bID = NewId()
        self.choosedirButton = wxButton(self, bID, "D")
        bc = wxLayoutConstraints()
        bc.top.SameAs(self, wxTop, 0)
        bc.left.SameAs(self, wxRight, -20)
        bc.bottom.Absolute(20)
        bc.right.SameAs(self, wxRight, 0)
        self.choosedirButton.SetConstraints(bc)
        EVT_BUTTON(self, bID, self.chooseDirDialog)
        
        self.InsertColumn(0, "Name")
        self.InsertColumn(1, "Size")
        self.InsertColumn(2, "Last Modified")
        self.InsertColumn(3, "")
        self.updateList()
                
    def updateList(self):
        lsListCtrl.updateList(self)
        self.locationText.Clear()
        self.locationText.WriteText(getcwd())
        wxSetCursor(wxStockCursor(wxCURSOR_WAIT))
        self.DeleteAllItems()   
        files = listdir('.')
        files.sort()
        files.reverse()
        
        for filename in files:
            i = self.InsertItem(wxListItem())
            statinfo = stat(filename)
            
            if isdir(filename): 
                self.SetStringItem(i, 0, filename, 0)
            else:  
                self.SetStringItem(i, 0, filename, 1)
            self.SetStringItem(i, 1, str(statinfo[6]))
            self.SetStringItem(i, 2, ctime(statinfo[8]))
            
            self.SetItemText(i, filename)
        
        i = self.InsertItem(wxListItem())
        self.SetStringItem(i, 0, '..')
        
        for j in range(i):
            self.EnsureVisible(j)
        wxSetCursor(wxStockCursor(wxCURSOR_ARROW))    
    
    def changedir(self, dirname):
        if isdir(dirname):
            chdir(dirname)
            return 1
        else:
            return 0

    def LocationTextEnter(self, event):
        if self.changedir(self.locationText.GetLineText(0)):
            self.updateList()

    def chooseDirDialog(self, event):
        dlg = wxDirDialog(self, "Choose a directory", getcwd())
        if dlg.ShowModal() == wxID_OK and self.changedir(dlg.GetPath()): 
            self.updateList()                
        dlg.Destroy()
